﻿using System;
using System.ComponentModel.DataAnnotations.Schema;

namespace IRaCIS.Core.Domain.Models
{
    [Table("ExchangeRate")]
    public class ExchangeRate : BaseFullAuditEntity
    {
        public string YearMonth { get; set; } = string.Empty;

        [Column(TypeName = "decimal(18,2)")]
        public decimal Rate { get; set; }

    }
}
